﻿@page
@model ContractModel
@{
    ViewData["Title"] = ViewData["layout"] == null ? "لیست قراردادها " : ViewData["Title"];
    ViewData["ActivePage"] = ManageNavPages.Contract;
    Layout = ViewData["layout"] == null ? "~/Areas/Identity/Pages/Account/Manage/_Layout.cshtml" : ViewData["layout"].ToString();
}

@section Styles{
    <environment include="Development">
        <link href="~/css/Grid.css" rel="stylesheet" />
    </environment>
    <environment exclude="Development">

        <link href="~/Publish/Grid.min.css" rel="stylesheet" />
    </environment>

}

<h6 class="m-b-20">@ViewData["Title"]</h6>

<div id="MyContracts">
    <form method="post"></form>
    <div class="table-responsive-sm UserOrder">
        <table class="table table-hover">
            <thead>
                <tr>
                    <th>
                        <span class="arrow-details">
                            <i class="fa fa-angle-up"></i>
                            <i class="fa fa-angle-down"></i>
                        </span>
                    </th>
                    <th scope="col">شناسه</th>
                    <th scope="col">تاریخ ایجاد</th>
                    <th scope="col">نام قرارداد</th>
                    <th scope="col">قیمت</th>
                    <th scope="col">تعداد ویرایش</th>
                    <th scope="col">وضعیت</th>
                    <th scope="col">عملیات</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td colspan="7"><img src="~/Images/Loader/ajax-loader.gif" /></td>
                </tr>
            </tbody>
        </table>
    </div>
</div>
<div style="display:none;" id="temperory-wrapper"></div>
@*#########################      Template          ####################################*@
<script id="grid-contracts-Themp" type="text/x-jsrender">

    {{for Contracts}}
    <tr>
        <td><span><i class="fa fa-angle-left customArrow"></i></span></td>
        <td>
            {{:OrderId}}
        </td>
        <td>{{:Time}}</td>
        <td title="{{:ContractName}}">{{:ContractName}}</td>
        <td>

            {{if Price == 0 || Price == null}}
            <span>  رایگان</span>
            {{/if}}

            {{if Price != 0 && Price != null && !Subscrib}}
            <span title="{{:~PriceFormat(Price)}}">{{:~PriceFormat(Price)}}</span>
            {{/if}}

            {{if Price != 0 && Price != null && Subscrib}}
            <span style="text-decoration:line-through;" title="{{:~PriceFormat(Price)}}">{{:~PriceFormat(Price)}}</span>
            <br /><span id="sub-profile">( استفاده از اشتراک )</span>
            {{/if}}

        </td>
        <td>{{:EditCount}}</td>
        <td>
            {{if status == 0}}
            <span style="color:#f44336;"> ناتمام</span>
            {{/if}}
            {{if status == 1}}   
            
            <span> تکمیل </span>
            {{/if}}
        </td>
        <td class="contract-actions">
            {{if status === 0 && Price === 0 || status === 0 && Price !== 0 && Payment || status === 0 && Price !== 0 && Subscrib}}
            <span onclick="CreateContract({{:UserContractID}} , this)">
                <span onclick='ga("send" , "event", "Profile", "onclick", "ایجاد قرارداد", "4")' class="wrapper-create-Contract">
                    <i class="fa fa-file-o"></i>
                    <img src="/Images/Loader/ajax-loader-score.gif" class="loader-CreateContract" style="display:none;margin-right:5px;" />
                    دریافت فایل PDF
                </span>
            </span>
            <br />
            <span onclick="CreateWordContract({{:UserContractID}} , this)">
                <span onclick='ga("send" , "event", "Profile", "onclick", "ایجاد قرارداد", "4")' class="wrapper-create-Contract">
                    <i class="fa fa-file-o"></i>
                    <img src="/Images/Loader/ajax-loader-score.gif" class="loader-CreateContract" style="display:none;margin-right:5px;" />
                    دریافت فایل Word
                </span>
            </span>

            {{/if}}

            {{if status === 0 && Price !== 0 && !Payment && !Subscrib}}
          
            <span data-info="{{:UserContractID}},{{:Price}},{{:ContractName}}" onclick="PaymentModal(this)" style="cursor:pointer;">
                <i class="fa fa-file-text-o"></i>
                تکمیل فرآیند
            </span>
            {{/if}}

        </td>
        <td id="lastChild-row"><input type="hidden" value="{{:UserContractID}}" /></td>
    </tr>
    {{/for}}

</script>
<script id="grid-Detail-Themp" type="text/x-jsrender">

    <tr class="detail-row">
        <td class="k-hierarchy-cell"></td>
        <td colspan="10">
            <div class="tabstrip">
                <ul class="k-tabstrip-items">
                    <li class="Tab-item active" data-Index="0">
                        <span>نسخه‌های تولید شده</span>
                    </li>
                    <li class="Tab-item" data-Index="1">
                        <span>تراکنش‌ها</span>
                    </li>
                </ul>
                <div class="Table" id="detail-contract-row">
                    <table>
                        <thead>
                            <tr>
                                <th>شناسه تولید</th>
                                <th>تاریخ ویرایش</th>
                                <th>PDF</th>
                                <th>Word</th>
                                @*<th>وضعیت نسخه</th>*@
                                <th>عملیات</th>
                            </tr>
                        </thead>
                        <tbody>
                            {{for Contracts}}
                            <tr>
                                <td style="cursor:default !important;">{{:OrderId}}</td>
                                <td>{{:Time}}</td>
                                <td>
                                    {{if PDF != "false"}}
                                    <a onclick='ga("send" , "event", "Profile", "onclick", "دریافت فایل PDF", "4")' title="دریافت فایل PDF" href="/Uploads/PdfFiles/{{:UserId}}/{{:PDF}}"><img src="/Images/file/pdf.png" width="35" /></a>
                                    {{/if}}
                                </td>
                                <td>
                                    {{if Word != "false"}}
                                    <a onclick='ga("send" , "event", "Profile", "onclick", "دریافت فایل PDF", "4")' title="دریافت فایل Word" href="/Uploads/WordFiles/{{:UserId}}/{{:Word}}"><img src="/Images/file/doc.png" width="35" /></a>
                                    {{/if}}
                                </td>
                                <td>
                                    @*{{if ~GetOrderNumber(OrderId) == 0}}
                                    نسخه اول
                                    {{/if}}
                                    {{if ~GetOrderNumber(OrderId) == 1}}
                                    نسخه دوم
                                    {{/if}}
                                    {{if ~GetOrderNumber(OrderId) == 2}}
                                    نسخه سوم
                                    {{/if}}*@
                                </td>
                                @*<td>
                                    {{if EditCount != null && EditCount<2 }}
                                    <a href="{{:~HostName()}}Contract-{{:ContractID}}/{{:~UrlFriendly(ContractName)}}/{{:~UrlFriendly(ContractEnglishName)}}/{{:UserContractID}}">ویرایش قرارداد</a>
                                    {{/if}}
                                </td>*@
                            </tr>
                            {{/for}}
                        </tbody>
                    </table>
                </div>
                <div class="Table" style="display:none;" id="detail-Payment-row">
                    <table>
                        <thead>
                            <tr>
                                <th>شناسه پرداخت</th>
                                <th>تاریخ</th>
                                <th>مبلغ</th>
                                <th>وضعیت پرداخت</th>
                                <th>کد پیگیری</th>
                                <th>درگاه پرداخت</th>
                            </tr>
                        </thead>
                        <tbody>
                            {{if Payments.length > 0}}
                            {{for Payments}}
                            <tr>
                                <td style="cursor:default !important;">{{:PaymentID}}</td>
                                <td>{{:ResponseCode}}</td>
                                <td>{{:~PriceFormat(Amount)}}</td>
                                <td>
                                    {{if IsSuccessful}}
                                    <span style="color:#4CAF50;font-weight:500;">پرداخت شده</span>
                                    {{else}}
                                    <span style="color:#f44336;font-weight:500;">عدم پرداخت</span>
                                    {{else}}
                                    {{/if}}
                                </td>
                                <td>{{:TrackingCode}}</td>
                                <td>{{:ReferenceBank}}</td>
                            </tr>
                            {{/for}}
                            {{else}}
                            <tr>
                                <td colspan="10">
                                    <span style="color:#f44336;font-weight:500;cursor:default !important;">در حال حاضر تراکنشی برای این قرارداد وجود ندارد .</span>
                                </td>
                            </tr>
                            {{else}}
                            {{/if}}

                        </tbody>
                    </table>
                </div>
            </div>
        </td>
    </tr>

</script>

@*#########################      Modals          ####################################*@

<div class="modal fade" id="Notification" tabindex="-1" role="dialog" aria-labelledby="Modal_Notification" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h6 class="modal-title" id="Modal_Notification">ایجاد فایل قرارداد</h6>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body text-right font-size-13">
                <p>کاربر گرامی فایل قرارداد مورد نظر ایجاد و در زیر شاخه این قرارداد قابل دسترس و دانلود می باشد .</p>
            </div>
        </div>
    </div>
</div>





@section Scripts{

    <script>

        var Address;
        if (window.location.href.includes("localhost")) Address = "https://localhost:5001/";
        else Address = "https://lawmingo.com/";
     

    $(document).ready(function () {
        getUserContracts();
    });

      //  change grid Tab
    $(document).on('click', '.k-tabstrip-items li', function () {

        $(this).parent("ul").find("li").removeClass("active");
        $(this).addClass("active");


        if ($(this).attr("data-Index") == '0') {

            $(this).parent("ul.k-tabstrip-items").next("#detail-contract-row").show();
            $(this).parent("ul.k-tabstrip-items").next().next("#detail-Payment-row").hide();

        }
        else
        {
             $(this).parent("ul.k-tabstrip-items").next("#detail-contract-row").hide();
              $(this).parent("ul.k-tabstrip-items").next().next("#detail-Payment-row").show();


        }
   });
    function getUserContracts() {

            $.ajax({

                type: "POST",
                url: "/Identity/Account/Manage/Contract?handler=Send",
                headers:
                {
                    "RequestVerificationToken": $('input:hidden[name="__RequestVerificationToken"]').val()
                },
                success: function (response) {

                    console.log(response)

                    var helper = {

                        PriceFormat: function (e) {
                            return e = e.toLocaleString()  + " " + " تومان ";
                         },
                          HostName: function () {
                                var hostName;
                                if (window.location.href.includes("localhost")) hostName = "https://localhost:5001/";
                                else hostName = "https://lawmingo.com/";
                                return hostName;
                         },
                         UrlFriendly: function (e) {
                          return e = e.replace(/\s+/g, '-');
                        },

                        GetOrderNumber: function (e) {
                             return e = e.split("/")[0]
                        }
                      };



                    // Inject data to master grid
                    var template = $.templates("#grid-contracts-Themp");
                    var htmlOutput = template.render(response, helper);
                    $("#MyContracts table tbody").html(htmlOutput);


                    // show table detail
                    $("#MyContracts table tbody tr td:nth-child(1)").click(function () {

                        var current = $(this);
                        var className = current.find('span i.customArrow').attr("class");

                        if (className !== undefined && className.includes("left")) {

                            current.find('span i').removeClass("fa-angle-left").addClass("fa fa-angle-down");

                            if (current.parent("tr").next().css("display") !== "none") {

                                $.ajax({

                                    type: "Get",
                                    url: "/Identity/Account/Manage/Contract?handler=Contracts",
                                    data: {
                                        userContractId: current.parent("tr").find("td:last-child").find("input[type='hidden']").val()
                                    },
                                    contentType: "application/json; charset=utf-8",
                                    dataType: "json",

                                    success: function (res) {

                                        var template = $.templates("#grid-Detail-Themp");
                                        var htmlOutput = template.render(res, helper);
                                        current.parent("tr").after(htmlOutput);

                                        console.log(res)
                                    }
                                });

                            }
                            else {
                                current.parent("tr").next().show();
                            }
                        }
                        else {

                            current.find('span i').removeClass("fa-angle-down").addClass("fa fa-angle-left");
                            current.parent("tr").next().hide();
                        }

                    });


                    // create contract for first if not created before
                    //$("table tr td span.wrapper-create-Contract").click(function () {

                    //     var usercontractId = $(this).parent("td").next().find("input[type='hidden']").val();
                    //     CreateContract(usercontractId ,'.loader-CreateContract' );
                    //});
                },

            });
        }
    function CreateContract(UserContractId , target) {

     $(target).find("img").show();
    //$(target).show();

    $.ajax({

        url: '/Contract/ArticleDetails',
        type: 'POST',
        dataType: 'json',
        data: {
            UserContractID: UserContractId
        },
         headers:
        {
            "RequestVerificationToken": $('#MyContracts form input:hidden[name="__RequestVerificationToken"]').val()
        },
        success: function (data) {


            //create Article Content with Data
            var content = "<form style='padding:15px;' id='contract'><div style='text-align:center;margin-bottom:80px;'><p style='font-weight:bold;text-align:center;font-size:26px;margin:0 auto !important;'>" + data.ContractName + "</p></div>";

            //content += "<h6 style='font-weight:bold;margin-bottom:40px;text-align:center;>" + data.ContractName  + "<h6>";

            for (var i = 0, len = data.Art.length; i < len; ++i) {

                content += "<p style='font-weight:bold;margin-bottom:20px;color:#6e1529'> ماده " + Number(data.Art[i].Article.split('-')[0]) + " - " + data.Art[i].Article.split('-')[1]+ "<p>";
                slicePluse = '';
                var counter = 0;
                for (var ii = 0; ii < data.Art[i].Content.length; ii++) {

                    if (data.Art[i].Content.length > 1) {

                        var con = data.Art[i].Content[ii];
                        con = con.replace('<p dir="RTL">', ' ').replace("</p>", " ").replace("placeholder", " ");

                        var count = (con.match(/===/g) || []).length;
                        var SliceCount = (slicePluse.match(/<p row>/g) || []).length;

                        //console.log("count : ", count)
                        //console.log("SliceCount : ", SliceCount)

                        if (count !== null && count >= 1) {

                            var slice = con.split('===');

                            for (var iii = 0; iii < slice.length; iii++) {

                                if (slice[iii] !== "   " && slice[iii] !== "" && slice[iii] !== " " && slice[iii] !== "&nbsp;" && slice[iii] !== " &nbsp;" && slice[iii] !== "&nbsp; ") {

                                    SliceCount = (slicePluse.match(/<p row>/g) || []).length;

                                    counter++;

                                    var row = '';
                                    row += "<p row>";
                                    row += data.Art[i].Article.split('-')[0];
                                    row += " - ";
                                    row += ii < 1 ? counter : SliceCount + 1;
                                    row += " ";
                                    row += slice[iii];
                                    row += " </p> ";

                                    slicePluse += row;
                                }
                            }

                        }
                        else {

                            row = '';
                            row += "<p row>";
                            row += data.Art[i].Article.split('-')[0];
                            row += " - ";
                            row += ii < 1 ? 1 : SliceCount + 1;
                            row += " ";
                            row += con;
                            row += " </p> ";

                            slicePluse += row;
                        }

                    }
                    else {
                        con = data.Art[i].Content[ii];
                        con = con.replace('<p dir="RTL">', ' ').replace("</p>", " ");

                        count = (con.match(/===/g) || []).length;
                        SliceCount = (slicePluse.match(/<p row>/g) || []).length;

                        if (count !== null && count >= 1) {
                            slice = con.split('===');

                            for (iii = 0; iii < slice.length; iii++) {

                                if (slice[iii] !== "   " && slice[iii] !== "" && slice[iii] !== " " && slice[iii] !== "&nbsp;" && slice[iii] !== " &nbsp;" && slice[iii] !== "&nbsp; ") {
                                    counter++;

                                    row = '';
                                    row += "<p row>";
                                    row += data.Art[i].Article.split('-')[0];
                                    row += " - ";
                                    row += counter;
                                    row += " ";
                                    row += slice[iii];
                                    row += " </p> ";

                                    slicePluse += row;
                                }
                            }

                        }
                        else {
                            slicePluse += "<p>" + con + "</p>";
                        }
                    }
                }

                content += slicePluse;
            }

            content += "</form>";

            content = content.replace(/ {1,}/g, " ");
            content = content.replace(/placeholder/g, " ");

            $("#temperory-wrapper").html(content);

            //bind properties to Artice Content
            data.Props.forEach(function (value, index) {

                var selector = "#temperory-wrapper input[id$='" + "-" + value.ArticlePropertyID + "']";
                $(selector).replaceWith("<span style='padding-left:10px;'>" + value.Value + "</span>");

            });

            $.ajax({
                url: '/ExportPdf/CreatePdfAsync',
                type: 'POST',
                data: {
                    Contract: $("#temperory-wrapper").html(),
                    userContractID: UserContractId,
                },
                dataType: 'json',
                success: function (res) {

                }
            })
                .always(function (fileName) {

                $("#temperory-wrapper").html(" ");
                 $(target).find("img").hide();
                getUserContracts();
                    $("#Notification").modal('show')

            });
        }
    });

        }

        function CreateWordContract(UserContractId , target) {
            
     $(target).find("img").show();
    //$(target).show();

    $.ajax({

        url: '/Contract/ArticleDetails',
        type: 'POST',
        dataType: 'json',
        data: {
            UserContractID: UserContractId
        },
         headers:
        {
            "RequestVerificationToken": $('#MyContracts form input:hidden[name="__RequestVerificationToken"]').val()
        },
        success: function (data) {


            //create Article Content with Data
            var content = "<form style='padding:15px;' id='contract'><div style='text-align:center;margin-bottom:80px;'><p style='font-weight:bold;text-align:center;font-size:26px;margin:0 auto !important;'>" + data.ContractName + "</p></div>";

            //content += "<h6 style='font-weight:bold;margin-bottom:40px;text-align:center;>" + data.ContractName  + "<h6>";

            for (var i = 0, len = data.Art.length; i < len; ++i) {

                content += "<p style='font-weight:bold;margin-bottom:20px;color:#6e1529'> ماده " + Number(data.Art[i].Article.split('-')[0]) + " - " + data.Art[i].Article.split('-')[1]+ "<p>";
                slicePluse = '';
                var counter = 0;
                for (var ii = 0; ii < data.Art[i].Content.length; ii++) {

                    if (data.Art[i].Content.length > 1) {

                        var con = data.Art[i].Content[ii];
                        con = con.replace('<p dir="RTL">', ' ').replace("</p>", " ").replace("placeholder", " ");

                        var count = (con.match(/===/g) || []).length;
                        var SliceCount = (slicePluse.match(/<p row>/g) || []).length;

                        //console.log("count : ", count)
                        //console.log("SliceCount : ", SliceCount)

                        if (count !== null && count >= 1) {

                            var slice = con.split('===');

                            for (var iii = 0; iii < slice.length; iii++) {

                                if (slice[iii] !== "   " && slice[iii] !== "" && slice[iii] !== " " && slice[iii] !== "&nbsp;" && slice[iii] !== " &nbsp;" && slice[iii] !== "&nbsp; ") {

                                    SliceCount = (slicePluse.match(/<p row>/g) || []).length;

                                    counter++;

                                    var row = '';
                                    row += "<p row>";
                                    row += data.Art[i].Article.split('-')[0];
                                    row += " - ";
                                    row += ii < 1 ? counter : SliceCount + 1;
                                    row += " ";
                                    row += slice[iii];
                                    row += " </p> ";

                                    slicePluse += row;
                                }
                            }

                        }
                        else {

                            row = '';
                            row += "<p row>";
                            row += data.Art[i].Article.split('-')[0];
                            row += " - ";
                            row += ii < 1 ? 1 : SliceCount + 1;
                            row += " ";
                            row += con;
                            row += " </p> ";

                            slicePluse += row;
                        }

                    }
                    else {
                        con = data.Art[i].Content[ii];
                        con = con.replace('<p dir="RTL">', ' ').replace("</p>", " ");

                        count = (con.match(/===/g) || []).length;
                        SliceCount = (slicePluse.match(/<p row>/g) || []).length;

                        if (count !== null && count >= 1) {
                            slice = con.split('===');

                            for (iii = 0; iii < slice.length; iii++) {

                                if (slice[iii] !== "   " && slice[iii] !== "" && slice[iii] !== " " && slice[iii] !== "&nbsp;" && slice[iii] !== " &nbsp;" && slice[iii] !== "&nbsp; ") {
                                    counter++;

                                    row = '';
                                    row += "<p row>";
                                    row += data.Art[i].Article.split('-')[0];
                                    row += " - ";
                                    row += counter;
                                    row += " ";
                                    row += slice[iii];
                                    row += " </p> ";

                                    slicePluse += row;
                                }
                            }

                        }
                        else {
                            slicePluse += "<p>" + con + "</p>";
                        }
                    }
                }

                content += slicePluse;
            }

            content += "</form>";

            content = content.replace(/ {1,}/g, " ");
            content = content.replace(/placeholder/g, " ");

            $("#temperory-wrapper").html(content);

            //bind properties to Artice Content
            data.Props.forEach(function (value, index) {

                var selector = "#temperory-wrapper input[id$='" + "-" + value.ArticlePropertyID + "']";
                $(selector).replaceWith("<span style='padding-left:10px;'>" + value.Value + "</span>");

            });

            $.ajax({
                  url: '/ExportWord/CreateWordAsync',
                type: 'POST',
                data: {
                    Contract: $("#temperory-wrapper").html(),
                    userContractID: UserContractId,
                },
                dataType: 'json',
                success: function (res) {

                }
            })
                .always(function (fileName) {

                $("#temperory-wrapper").html(" ");
                 $(target).find("img").hide();
                getUserContracts();
                    $("#Notification").modal('show')

            });
        }
    });
        }
    function Edit(contractID, UserContractID) {
             
            window.location = Address + 'Contract/GetPage?ContractID=' +contractID + "&Id=" +UserContractID;
        }
    </script>

}
